# cpp_type_traits.h File Reference

## Detailed Description

This is an internal header file, included by other library headers. You should not attempt to use it directly.

Definition in file cpp_type_traits.h.

Go to the source code of this file.

## Namespaces

- namespace __gnu_cxx
- namespace std
- namespace std::__detail

## Classes

- struct std::__are_same<, >
- struct std::__are_same< _Tp, _Tp >
- struct std::__false_type
- struct std::__is_arithmetic< _Tp >
- struct std::__is_char< _Tp >
- struct std::__is_char< char >
- struct std::__is_char< wchar_t >
- struct std::__is_empty< _Tp >
- struct std::__is_floating< _Tp >
- struct std::__is_floating< double >
- struct std::__is_floating< float >
- struct std::__is_floating< long double >
- struct std::__is_fundamental< _Tp >
- struct std::__is_integer< _Tp >
- struct std::__is_integer< bool >
- struct std::__is_integer< char >
- struct std::__is_integer< int >
- struct std::__is_integer< long >
- struct std::__is_integer< long long >
- struct std::__is_integer< short >
- struct std::__is_integer< signed char >
- struct std::__is_integer< unsigned char >
- struct std::__is_integer< unsigned int >
- struct std::__is_integer< unsigned long >
- struct std::__is_integer< unsigned long long >
- struct std::__is_integer< unsigned short >
- struct std::__is_integer< wchar_t >
- struct std::__is_normal_iterator< _Tp >
- struct std::__is_normal_iterator< __gnu_cxx::__normal_iterator< _Iterator, _Container > >
- struct std::__is_pod< _Tp >
- struct std::__is_pointer< _Tp >
- struct std::__is_pointer< _Tp * >
- struct std::__is_scalar< _Tp >
- struct std::__is_void< _Tp >
- struct std::__is_void< void >
- struct std::__traitor< _Sp, _Tp >
- struct std::__true_type
- struct std::__truth_type<>
- struct std::__truth_type< true >

## Defines

- #define _CPP_TYPE_TRAITS_H

## Typedefs

- typedef char std::__detail::__one
- typedef char std::__detail::__two [2]

## Functions

- template<typename _Tp> __two & std::__detail::__test_type (...)
- template<typename _Tp> __one std::__detail::__test_type (int _Tp::*)